/******************(abc914-18857.c)***
 *  SDJ[h̓ǂݏ
 * @iEUSART荞ݗLj
 *************************************/
#include "mcc_generated_files/mcc.h"
#include <stdio.h>

// File Systme@ϐ
FRESULT  result;
FATFS    drive;
FIL      file;
char     FilNam[13] = "LOGDATA.TXT";

// Avϐ
uint16_t Length[2];
char     Buffer[80];
char     Msg[40];

// ϐ`
uint8_t     rcv, tFlag;
char        buf[32];
uint16_t    Counter;

/*****************************
 * obt@o͊֐
 *****************************/
void StrWrite(char * str){
    while(*str != 0){                   // 0x00܂ŌJԂ
        EUSART_Write(*str++);           // 1obt@ɏo
    }
}

void US_Puts(char * str){
	char bf[80];
	sprintf(bf,"%s\n",str);
    StrWrite(bf);
}

/****************************************
 *  ^C}0 Callback֐ (1b荞)
 ****************************************/
void TMR0_Process(void){
    tFlag = 1;           // tOZbg
}

/*****************************
 * R}h
 *****************************/
void SD_cmd_T(){
	uint8_t i = 0;
    FRESULT res;

    US_Puts("Start Command T");
    do{
        res = f_mount(&drive,"0:",1);     
        i++;
        EUSART_Write('-');
    }while((res != FR_OK) && (i < 10));
    
    if(res != FR_OK){
        US_Puts("** SD Not Mounted !!");
    }else {                                  // }Eg
        US_Puts("SD Mount OK!");
        LED_SetHigh();
        __delay_ms(2000);
    
        f_mount(0, "0:", 0);                    // A}Eg
        US_Puts("Un_Mounted"); 
    }
}

void SD_cmd_R(){
	uint8_t i = 0;
    FRESULT res,res2;

    US_Puts("Start Command R");
    do{
        res = f_mount(&drive,"0:",1);     
        i++;
        EUSART_Write('-');
    }while((res != FR_OK) && (i < 10));
    
    if(res != FR_OK){
        US_Puts("** Not SD Mounted !!");
    }else {                                  // }Eg
        US_Puts("SD Mount OK!");
        LED_SetHigh();
        __delay_ms(500);
        res2 = f_open(&file, FilNam, FA_READ);
        if(res2 == FR_OK){
            sprintf(Msg,"Open %s",FilNam);
            US_Puts(Msg);
            do{
                f_read(&file, Buffer, 64, (UINT *)Length); 
                Buffer[Length[0]] = 0;
                US_Puts(Buffer);
            }while(Length[0]!=0);
        }else{
            sprintf(Msg,"** Can't open %s !!",FilNam);
             US_Puts(Msg);           
        }
        f_close(&file);                         // t@CN[Y
        f_mount(0, "0:", 0);                    // A}Eg
        US_Puts("closed & Un_Mounted"); 
    }
    LED_SetLow();
}

void SD_cmd_W(){
	uint8_t i = 0;
    FRESULT res,res2;

    US_Puts("Start Command W");
    do{
        res = f_mount(&drive,"0:",1);     
        i++;
        EUSART_Write('-');
    }while((res != FR_OK) && (i < 10));
    
    if(res != FR_OK){
        US_Puts("** Not SD Mounted !!");
    }else {                                  // }Eg
        US_Puts("SD Mount OK!");
        LED_SetHigh();
        __delay_ms(500);
        res2 = f_open(&file, FilNam, FA_WRITE | FA_OPEN_APPEND);
        if(res2 == FR_OK){
            sprintf(Msg,"Open %s",FilNam);
            US_Puts(Msg);
            sprintf(Msg, "%07d,", Counter);
            f_write(&file, Msg, 8, (UINT *)Length);
            US_Puts(Msg);
        }else{
            sprintf(Msg,"** Can't open %s !!",FilNam);
             US_Puts(Msg);           
        }
        f_close(&file);                         // t@CN[Y
        f_mount(0, "0:", 0);                    // A}Eg
        US_Puts("closed & Un_Mounted"); 
    }
    LED_SetLow();
}

/*** C֐ *************************/
void main(void)
{
    uint8_t mFlg = 1;
    SYSTEM_Initialize();
    // ^C}0 Callback֐`
    TMR0_SetInterruptHandler(TMR0_Process);
    
    US_Puts("\n==== SD Test ====");
    
    // 荞݋
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    
    /*** C[v ********************/
    while(1)
    {
        // 1b̏
        if(tFlag == 1){                                  // tȈꍇ
            tFlag = 0;                                   // tOZbg
            sprintf(buf, "Counter = %05d", Counter++);    // JEglҏW
            US_Puts(buf);                              // M
            LED_Toggle();
        }
        // R}h
        if(EUSART_is_rx_ready()){                       // M̏ꍇ
            rcv = EUSART_Read();                        // 1M
            StrWrite("\r\nInput = ");                   // bZ[WM
            EUSART_Write(rcv);                          // GR[M
            EUSART_Write(' ');                          // Xy[X
            switch(rcv){
                case 'T':   SD_cmd_T();  break;
                case 'R':   SD_cmd_R();  break;
                case 'W':   SD_cmd_W();  break;
                case 'E':   US_Puts("*** End !! ***");
                            exit(0);    break;
    
                default:    US_Puts("???"); break; 
            }// ???M
        }
    }
}
/******  End of File ******/
